Index: .bzrignore
===================================================================
--- .bzrignore	(revision 50971113bd9944b49442287c33c900882bf810a5)
+++ .bzrignore	(revision 50971113bd9944b49442287c33c900882bf810a5)
@@ -0,0 +1,263 @@
+*.disasm
+*.map
+*.prev
+Makefile.depend
+Makefile.common
+Makefile.config
+autotool/
+common.h
+config.h
+hdisk.img
+image.iso
+boot/distroot/
+boot/initrd.img
+kernel/kernel.bin
+kernel/kernel.dump
+kernel/kernel.raw
+kernel/arch/amd64/_link.ld
+kernel/arch/amd64/include/arch/common.h
+kernel/generic/src/debug/real_map.bin
+uspace/app/bdsh/bdsh
+uspace/app/bithenge/bithenge
+uspace/app/blkdump/blkdump
+uspace/app/bnchmark/bnchmark
+uspace/app/date/date
+uspace/app/devctl/devctl
+uspace/app/dnscfg/dnscfg
+uspace/app/dnsres/dnsres
+uspace/app/edit/edit
+uspace/app/getterm/getterm
+uspace/app/inet/inet
+uspace/app/init/init
+uspace/app/kill/kill
+uspace/app/killall/killall
+uspace/app/klog/klog
+uspace/app/loc/loc
+uspace/app/logset/logset
+uspace/app/mixerctl/mixerctl
+uspace/app/mkbd/mkbd
+uspace/app/mkexfat/mkexfat
+uspace/app/mkfat/mkfat
+uspace/app/mkmfs/mkmfs
+uspace/app/netecho/netecho
+uspace/app/nettest1/nettest1
+uspace/app/nettest2/nettest2
+uspace/app/nettest3/nettest3
+uspace/app/nterm/nterm
+uspace/app/ping/ping
+uspace/app/ping6/ping6
+uspace/app/redir/redir
+uspace/app/sbi/sbi
+uspace/app/sportdmp/sportdmp
+uspace/app/stats/stats
+uspace/app/sysinfo/sysinfo
+uspace/app/taskdump/taskdump
+uspace/app/tester/tester
+uspace/app/testread/testread
+uspace/app/testwrit/testwrit
+uspace/app/tetris/tetris
+uspace/app/top/top
+uspace/app/trace/trace
+uspace/app/usbinfo/usbinfo
+uspace/app/vdemo/vdemo
+uspace/app/vlaunch/images.c
+uspace/app/vlaunch/images.h
+uspace/app/vlaunch/vlaunch
+uspace/app/vterm/vterm
+uspace/app/vuhid/vuh
+uspace/app/wavplay/wavplay
+uspace/app/websrv/websrv
+uspace/dist/app/bdsh
+uspace/dist/app/bithenge
+uspace/dist/app/blkdump
+uspace/dist/app/bnchmark
+uspace/dist/app/date
+uspace/dist/app/devctl
+uspace/dist/app/dnscfg
+uspace/dist/app/dnsres
+uspace/dist/app/edit
+uspace/dist/app/getterm
+uspace/dist/app/inet
+uspace/dist/app/kill
+uspace/dist/app/killall
+uspace/dist/app/klog
+uspace/dist/app/loc
+uspace/dist/app/logset
+uspace/dist/app/mixerctl
+uspace/dist/app/mkbd
+uspace/dist/app/mkexfat
+uspace/dist/app/mkfat
+uspace/dist/app/mkmfs
+uspace/dist/app/netecho
+uspace/dist/app/nettest1
+uspace/dist/app/nettest2
+uspace/dist/app/nettest3
+uspace/dist/app/nterm
+uspace/dist/app/ping
+uspace/dist/app/ping6
+uspace/dist/app/redir
+uspace/dist/app/sbi
+uspace/dist/app/sportdmp
+uspace/dist/app/stats
+uspace/dist/app/sysinfo
+uspace/dist/app/taskdump
+uspace/dist/app/tester
+uspace/dist/app/testread
+uspace/dist/app/testwrit
+uspace/dist/app/tetris
+uspace/dist/app/top
+uspace/dist/app/trace
+uspace/dist/app/usbinfo
+uspace/dist/app/vdemo
+uspace/dist/app/vlaunch
+uspace/dist/app/vterm
+uspace/dist/app/vuh
+uspace/dist/app/wavplay
+uspace/dist/app/websrv
+uspace/dist/drv/ahci/
+uspace/dist/drv/ata_bd/
+uspace/dist/drv/cmos-rtc/
+uspace/dist/drv/e1k/
+uspace/dist/drv/ehci/
+uspace/dist/drv/i8042/
+uspace/dist/drv/isa/
+uspace/dist/drv/kfb/
+uspace/dist/drv/ne2k/
+uspace/dist/drv/ns8250/
+uspace/dist/drv/ohci/
+uspace/dist/drv/pciintel/
+uspace/dist/drv/ps2mouse/
+uspace/dist/drv/root/
+uspace/dist/drv/rootpc/
+uspace/dist/drv/rootvirt/
+uspace/dist/drv/rtl8139/
+uspace/dist/drv/sb16/
+uspace/dist/drv/test1/
+uspace/dist/drv/test2/
+uspace/dist/drv/test3/
+uspace/dist/drv/uhci/
+uspace/dist/drv/uhcirh/
+uspace/dist/drv/usbflbk/
+uspace/dist/drv/usbhid/
+uspace/dist/drv/usbhub/
+uspace/dist/drv/usbmast/
+uspace/dist/drv/usbmid/
+uspace/dist/drv/vhc/
+uspace/dist/drv/xtkbd/
+uspace/dist/srv/apic
+uspace/dist/srv/cdfs
+uspace/dist/srv/clipboard
+uspace/dist/srv/compositor
+uspace/dist/srv/console
+uspace/dist/srv/devman
+uspace/dist/srv/dnsrsrv
+uspace/dist/srv/ethip
+uspace/dist/srv/exfat
+uspace/dist/srv/ext4fs
+uspace/dist/srv/fat
+uspace/dist/srv/file_bd
+uspace/dist/srv/g_part
+uspace/dist/srv/hound
+uspace/dist/srv/i8259
+uspace/dist/srv/inetsrv
+uspace/dist/srv/input
+uspace/dist/srv/isdv4_tablet
+uspace/dist/srv/locfs
+uspace/dist/srv/loopip
+uspace/dist/srv/mbr_part
+uspace/dist/srv/mfs
+uspace/dist/srv/output
+uspace/dist/srv/remcons
+uspace/dist/srv/sata_bd
+uspace/dist/srv/slip
+uspace/dist/srv/taskmon
+uspace/dist/srv/tcp
+uspace/dist/srv/tmpfs
+uspace/dist/srv/udf
+uspace/dist/srv/udp
+uspace/drv/audio/sb16/sb16
+uspace/drv/block/ahci/ahci
+uspace/drv/block/ata_bd/ata_bd
+uspace/drv/bus/isa/isa
+uspace/drv/bus/pci/pciintel/pciintel
+uspace/drv/bus/usb/ehci/ehci
+uspace/drv/bus/usb/ohci/ohci
+uspace/drv/bus/usb/uhci/uhci
+uspace/drv/bus/usb/uhcirh/uhcirh
+uspace/drv/bus/usb/usbflbk/usbflbk
+uspace/drv/bus/usb/usbhid/usbhid
+uspace/drv/bus/usb/usbhub/usbhub
+uspace/drv/bus/usb/usbmast/usbmast
+uspace/drv/bus/usb/usbmid/usbmid
+uspace/drv/bus/usb/vhc/vhc
+uspace/drv/char/i8042/i8042
+uspace/drv/char/ns8250/ns8250
+uspace/drv/char/ps2mouse/ps2mouse
+uspace/drv/char/xtkbd/xtkbd
+uspace/drv/fb/kfb/kfb
+uspace/drv/infrastructure/root/root
+uspace/drv/infrastructure/rootpc/rootpc
+uspace/drv/infrastructure/rootvirt/rootvirt
+uspace/drv/nic/e1k/e1k
+uspace/drv/nic/ne2k/ne2k
+uspace/drv/nic/rtl8139/rtl8139
+uspace/drv/test/test1/test1
+uspace/drv/test/test2/test2
+uspace/drv/test/test3/test3
+uspace/drv/time/cmos-rtc/cmos-rtc
+uspace/lib/c/arch/amd64/_link-dlexe.ld
+uspace/lib/c/arch/amd64/_link-loader.ld
+uspace/lib/c/arch/amd64/_link-shlib.ld
+uspace/lib/c/arch/amd64/_link.ld
+uspace/lib/c/arch/amd64/include/libarch/common.h
+uspace/lib/posix/collisions.list
+uspace/lib/posix/redefs-hide-libc.xargs
+uspace/lib/posix/redefs-show-posix.xargs
+uspace/lib/posix/include/libc
+uspace/srv/audio/hound/hound
+uspace/srv/bd/file_bd/file_bd
+uspace/srv/bd/part/guid_part/g_part
+uspace/srv/bd/part/mbr_part/mbr_part
+uspace/srv/bd/rd/rd
+uspace/srv/bd/sata_bd/sata_bd
+uspace/srv/clipboard/clipboard
+uspace/srv/devman/devman
+uspace/srv/fs/cdfs/cdfs
+uspace/srv/fs/exfat/exfat
+uspace/srv/fs/ext4fs/ext4fs
+uspace/srv/fs/fat/fat
+uspace/srv/fs/locfs/locfs
+uspace/srv/fs/mfs/mfs
+uspace/srv/fs/tmpfs/tmpfs
+uspace/srv/fs/udf/udf
+uspace/srv/hid/compositor/compositor
+uspace/srv/hid/compositor/images.c
+uspace/srv/hid/compositor/images.h
+uspace/srv/hid/console/console
+uspace/srv/hid/input/input
+uspace/srv/hid/isdv4_tablet/isdv4_tablet
+uspace/srv/hid/output/output
+uspace/srv/hid/remcons/remcons
+uspace/srv/hid/s3c24xx_ts/s3c24xx_ts
+uspace/srv/hw/char/s3c24xx_uart/s3c24ser
+uspace/srv/hw/irc/apic/apic
+uspace/srv/hw/irc/i8259/i8259
+uspace/srv/loader/loader
+uspace/srv/locsrv/locsrv
+uspace/srv/logger/logger
+uspace/srv/net/dnsrsrv/dnsrsrv
+uspace/srv/net/ethip/ethip
+uspace/srv/net/inetsrv/inetsrv
+uspace/srv/net/loopip/loopip
+uspace/srv/net/slip/slip
+uspace/srv/net/tcp/tcp
+uspace/srv/net/udp/udp
+uspace/srv/ns/ns
+uspace/srv/taskmon/taskmon
+uspace/srv/vfs/vfs
+kernel/arch/ia32/_link.ld
+uspace/lib/c/arch/ia32/_link-dlexe.ld
+uspace/lib/c/arch/ia32/_link-loader.ld
+uspace/lib/c/arch/ia32/_link-shlib.ld
+uspace/lib/c/arch/ia32/_link.ld
+kernel/arch/arm32/_link.ld